class ExceptionManager:
    def __init__(self, exception):
        self.exception = exception

    def divide_and_force(self, analyzed_job, queue):
        from AutoRPE.UtilsWorkflow.Errors import NoException
        if self.exception == NoException:
            queue[analyzed_job.status].remove(analyzed_job)
            analyzed_job.status = "FAILED"
            queue.failed.append(analyzed_job)
            analyzed_job.print_info_job("failed")
        else:
            # Exception handling
            analyzed_job.print_info_job("suspended")
            print("Exception found!", analyzed_job.kind_of_exception())
            queue[analyzed_job.status].remove(analyzed_job)
            queue.suspended.append(analyzed_job)
            analyzed_job.status = "SUSPENDED"

            child_1, child_2 = analyzed_job.child
            hash_1, hash_2 = child_1.hash, child_2.hash
            # Make that the analysis variables of one child are the forced variables of the other one
            if child_1.forced_variables is not None:
                child_1.forced_variables.extend(child_2.analysis_set)
                child_2.forced_variables.extend(child_1.analysis_set)
            else:
                child_1.forced_variables = child_2.analysis_set
                child_2.forced_variables = child_1.analysis_set

            child_1.forced_variables = [v for v in child_1.forced_variables if v not in analyzed_job.banned_variables]
            child_2.forced_variables = [v for v in child_2.forced_variables if v not in analyzed_job.banned_variables]
            # Avoid loops making them fail
            if child_1.hash == hash_1 or child_2.hash == hash_2:
                queue[analyzed_job.status].remove(analyzed_job)
                analyzed_job.status = "FAILED"
                queue.failed.append(analyzed_job)
                analyzed_job.print_info_job("failed")
            else:
                for ch in analyzed_job.child:
                    if ch in queue.all():
                        queue[ch.status].remove(ch)
                    queue.pending.append(ch)
                    ch.status = "PENDING"
                    # Disinherit all child's descendants
                    for job in ch.descendants():
                        job.parent = None
                    ch.child = None
            # Save disinherited jobs
            disinherited = [j for j in queue.all() if j.parent is None and j.level != 0]
            for job in disinherited:
                queue[job.status].remove(job)
                if job not in queue.disinherited:
                    queue.disinherited.append(job)

    # Do not perform other action, the set is considered as FAILED
    def divide_or_fail(self, analyzed_job, queue):
        queue[analyzed_job.status].remove(analyzed_job)
        analyzed_job.status = "FAILED"
        queue.failed.append(analyzed_job)
        analyzed_job.print_info_job("failed")

